
Redmine - Feature #10485

Add new context menu in Gantt view for each issue

2012-03-19 18:21 - Dieter Egert

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Gantt Estimated time: 0.00 hour

Target version: 4.0.0   

Resolution: Fixed   

Description

In gantt view there is no way to manage any issue.

But just here you can see and evaluate many things of the project.

So it would be a great help if here is used the same context menu as already used in the issue list.

Associated revisions

Revision 17030 - 2017-11-25 17:30 - Go MAEDA

Add right-click context menu to gantt subjects (#10485).

Contributed by Mizuki ISHIKAWA.

Revision 17031 - 2017-11-25 17:31 - Go MAEDA

Add right-click context menu to gantt bars (#10485).

Contributed by Mizuki ISHIKAWA.

Revision 17037 - 2017-11-27 01:34 - Go MAEDA

Add tests for context menu in gantt (#10485).

Patch by Marius BALTEANU.

History

#1 - 2012-03-19 23:16 - Terence Mill

+1

Additionally modifying start date, due date, progress and issue relations is useful in context of gant.

THis is not directly part of nowadays context menu

#2 - 2012-03-20 09:20 - morlockmaria John

- Assignee set to Jim Mulholland

#3 - 2012-03-20 14:04 - Etienne Massip

- Assignee deleted (Jim Mulholland)

#4 - 2013-07-09 15:56 - Michael Heinze

+1

We also hope for this feature to be implemented.

#5 - 2014-03-14 16:29 - Christian Dähn

+1

I'm currently experimenting how to solve that - sadly I'm currently very unexperienced in Ruby/Rails programming...

#6 - 2014-04-04 16:45 - Christian Dähn

- File gantt_context_menu.diff added

As Ruby noob I tried to understand how to implement context menus in Redmine, but currently I'm stucked with some (derivation?) problems with the

view hooks and the Gantt class.
Currently I implemented inside Gantt:

the context menu attributes for CSS

the context menu hooks / placeholders in show.erb

added the context_menu_link() for each issue, which causes the following error:

Started GET "/redmine/projects/huk_handerfassung/issues/gantt" for 192.168.10.30 at Tue Apr 01 15:34:34 +0200 

2014

Processing by GanttsController#show as HTML

  Parameters: {"project_id"=>"huk_handerfassung"}

  Current user: chris (id=2)

  Rendered queries/_filters.html.erb (45.0ms)

  Rendered gantts/show.html.erb within layouts/base (444.3ms)

Completed 500 Internal Server Error in 1061.5ms

ActionView::Template::Error (undefined method `link_to' for #<Redmine::Helpers::Gantt:0xb463e6d8>):

    102: 

    103:   # Width of the entire chart

    104:   g_width = ((@gantt.date_to - @gantt.date_from + 1) * zoom).to_i

    105:   @gantt.render(:top => headers_height + 8,

    106:                 :zoom => zoom,

    107:                 :g_width => g_width,

    108:                 :subject_width => subject_width)

  app/helpers/context_menus_helper.rb:34:in `context_menu_link'

  lib/redmine/helpers/gantt.rb:387:in `subject_for_issue'

  lib/redmine/helpers/gantt.rb:239:in `render_issues'

  lib/redmine/helpers/gantt.rb:238:in `each'

  lib/redmine/helpers/gantt.rb:238:in `render_issues'

  lib/redmine/helpers/gantt.rb:224:in `render_project'

  lib/redmine/helpers/gantt.rb:206:in `render'

  app/models/project.rb:748:in `project_tree'

  app/models/project.rb:744:in `each'

  app/models/project.rb:744:in `project_tree'

  lib/redmine/helpers/gantt.rb:204:in `render'

  app/views/gantts/show.html.erb:105:in `_app_views_gantts_show_html_erb___32399475__631731208'

  app/controllers/gantts_controller.rb:44:in `show'

  app/controllers/gantts_controller.rb:43:in `show'

 Attached my diff (created by svn diff command) for the following SVN version of Redmine:

RL: http://svn.redmine.org/redmine/branches/2.4-stable

Basis des Projektarchivs: http://svn.redmine.org/redmine

UUID des Projektarchivs: e93f8b46-1217-0410-a6f0-8f06a7374b81

Revision: 13036

Knotentyp: Verzeichnis

Plan: normal

Letzter Autor: jplang

Letzte geänderte Rev: 13031

Letztes Änderungsdatum: 2014-03-29 17:06:51 +0100 (Sa, 29. Mär 2014)

 Environment:

> Debian Wheezy + Apache2 + mod_passenger + Redmine 2.4

> bundle show

Gems included by the bundle:

  * actionmailer (3.2.17)

  * actionpack (3.2.17)

  * activemodel (3.2.17)

  * activerecord (3.2.17)

  * activeresource (3.2.17)

  * activesupport (3.2.17)

  * arel (3.0.3)

  * builder (3.0.0)

  * bundler (1.3.5)

  * coderay (1.1.0)

  * erubis (2.7.0)

  * fastercsv (1.5.5)

  * hike (1.2.3)

  * i18n (0.6.9)

  * journey (1.0.4)

  * jquery-rails (2.0.3)

  * json (1.8.1)

  * mail (2.5.4)

  * mime-types (1.25.1)

  * multi_json (1.9.2)
  * mysql2 (0.3.15)

  * net-ldap (0.3.1)

  * polyglot (0.3.4)

  * rack (1.4.5)

  * rack-cache (1.2)

  * rack-openid (1.4.2)

  * rack-ssl (1.3.4)

  * rack-test (0.6.2)

  * rails (3.2.17)

  * railties (3.2.17)

  * rake (10.1.1)

  * rdoc (3.12.2)

  * rmagick (2.13.2)

  * ruby-openid (2.3.0)

  * sprockets (2.2.2)

  * thor (0.19.1)

  * tilt (1.4.1)

  * treetop (1.4.15)

  * tzinfo (0.3.39)

 Has anybody a hint how to solve this undefined method error? I already tried to let the class Gantt inherit the view listener hook class, but this lead to

much more errors :(

#7 - 2014-04-13 00:26 - Toshi MARUYAMA

- Category set to Gantt

#8 - 2015-03-06 00:01 - mark burdett

Here's a sample UI for editing issue timelines directly from a gantt chart: http://teamgantt.com/img/test3.gif

#9 - 2015-03-06 01:23 - Christian Dähn

That looks great - would really love to see it in Redmine - because even with plugins like "redmine_planning" working with industry leading methods

like Gantt is a (sorry) pain in the ass with (community) Redmine.

Currently only commercial Redmine forks have a really neat usability, while the community version lacks even very basic features like a simple

context menu.

I'm hardly trying to dive into plugin programming which is really hard thanks to the lack of docu and help of the devs.

Sadly nobody cares about new contributors.

#10 - 2017-07-13 08:00 - Mizuki ISHIKAWA

- File 0001-Add-context-menu-to-the-issue-subjects.patch added

- File 0002-Add-context-menu-to-the-task-bar.patch added

- File issue_subject.png added

- File task_bar.png added

Please try out the attached patch series.

By applying the patches, a context menu is added on each issues and gantt bars. You will be able to manipulate the issue through the context menu. I

think the gantt chart will be easier to use.

issue_subject.png task_bar.png 

#11 - 2017-07-13 08:48 - Akipii Oga

+100 !!

I also want to operate the Gantt Chart on the context menu like a Roadmap or Issue list.

#12 - 2017-07-17 07:21 - Go MAEDA

- Target version set to 4.1.0

This simple patch greatly improves UI/UX of gantt.

Let's deliver this feature in the next major release.

#13 - 2017-11-25 17:35 - Go MAEDA

- Status changed from New to Closed
- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

- Resolution set to Fixed

Committed in the trunk.

Mizuki ISHIKAWA, thank you for improving Redmine.

#14 - 2017-11-27 01:15 - Marius BĂLTEANU

- File tests_for_context_menu_in_gantts.patch added

- Status changed from Closed to Reopened

I've added some basic assertions for this feature.

#15 - 2017-11-27 01:38 - Go MAEDA

- Status changed from Reopened to Closed

Marius BALTEANU wrote:

I've added some basic assertions for this feature.

 Committed. Thank you.

Files

gantt_context_menu.diff 2.58 KB 2014-04-04 Christian Dähn

0002-Add-context-menu-to-the-task-bar.patch 2.68 KB 2017-07-13 Mizuki ISHIKAWA

0001-Add-context-menu-to-the-issue-subjects.patch 2.71 KB 2017-07-13 Mizuki ISHIKAWA

task_bar.png 225 KB 2017-07-13 Mizuki ISHIKAWA

issue_subject.png 236 KB 2017-07-13 Mizuki ISHIKAWA

tests_for_context_menu_in_gantts.patch 663 Bytes 2017-11-27 Marius BĂLTEANU
